// ESP_now_LED_ctrl_Rx.ino
// ESP32 @ IDE 1.8.16

#include <esp_now.h>
#include <WiFi.h>

byte LEDpin=4;
int frequency=1000, resolution=8, channel=0;

typedef struct struct_message 
{ int brightness;} struct_message;
struct_message myData;

void OnDataRecv(const uint8_t * mac, const uint8_t *incomingData, int len) 
{ memcpy(&myData, incomingData, sizeof(myData));
  Serial.print("Received Data: "); Serial.println(myData.brightness);
  ledcWrite(channel,myData.brightness/16);
}
 
void setup() 
{ Serial.begin(115200); WiFi.mode(WIFI_STA);
  pinMode(LEDpin,OUTPUT);
  ledcSetup(channel,frequency,resolution); ledcAttachPin(LEDpin,channel);
  if (esp_now_init() != ESP_OK) 
  { Serial.println("Error initializing ESP-NOW"); return;}
  esp_now_register_recv_cb(OnDataRecv);
}
 
void loop() {}
