// ESP_now_4_channel_RC_Rx.ino
// ESP32 @ IDE 1.8.16

#define ADCtoDEG 180/4095 // convert ADC readings to Servo degrees

#include <esp_now.h>
#include <WiFi.h>
#include <Servo.h>

Servo myservo1; Servo myservo2; Servo myservo3; Servo myservo4;// 12 servo objects max
int servoPos01=0, servoPos02=0, servoPos03=0, servoPos04=0;  // servo positions

typedef struct struct_message 
{ int servoPos01; int servoPos02; int servoPos03; int servoPos04;} struct_message;
struct_message myData;

void OnDataRecv(const uint8_t * mac, const uint8_t *incomingData, int len) 
{ memcpy(&myData, incomingData, sizeof(myData));
  Serial.println(myData.servoPos01*ADCtoDEG); Serial.println(myData.servoPos02*ADCtoDEG);  
  Serial.println(myData.servoPos03*ADCtoDEG); Serial.println(myData.servoPos04*ADCtoDEG);  
  Serial.println("====================");
  
  myservo1.write(myData.servoPos01*ADCtoDEG); myservo2.write(myData.servoPos02*ADCtoDEG);  
  myservo3.write(myData.servoPos03*ADCtoDEG); myservo4.write(myData.servoPos04*ADCtoDEG);  
}
 
void setup() 
{ Serial.begin(115200); WiFi.mode(WIFI_STA);
  if (esp_now_init()!= ESP_OK) {Serial.println("Error initializing ESP-NOW"); return;}
  esp_now_register_recv_cb(OnDataRecv);
  myservo1.attach(13); myservo2.attach(12); myservo3.attach(15); myservo4.attach(18);  
}
 
void loop() {}
