// ESP_now_4_channel_RC_Tx.ino
// ESP32 @ IDE 1.8.16

#include <esp_now.h>
#include <WiFi.h>
// uint8_t broadcastAddress[] = {0x80, 0x7D, 0x3A, 0xDD, 0x12, 0x84}; // receiver MAC adress
uint8_t broadcastAddress[] = {0x30,0xAE,0xA4,0xF5,0x7A,0xE8}; // receiver MAC adress
byte ch01=34, ch02=35, ch03=32, ch04=33; 

typedef struct struct_message 
{int servoPos01; int servoPos02; int servoPos03; int servoPos04;} struct_message;
struct_message myData; esp_now_peer_info_t peerInfo;

void OnDataSent(const uint8_t *mac_addr, esp_now_send_status_t status) 
{ Serial.print(status==ESP_NOW_SEND_SUCCESS?"Package sent\t":"Send Fail\t");}
 
void setup() 
{ Serial.begin(115200);  WiFi.mode(WIFI_STA);
  if (esp_now_init()!= ESP_OK) { Serial.println("Error initializing ESP-NOW"); return;}
  esp_now_register_send_cb(OnDataSent);
  memcpy(peerInfo.peer_addr, broadcastAddress, 6); // 6 digit MAC
  peerInfo.channel=0; peerInfo.encrypt=false;
  if (esp_now_add_peer(&peerInfo)!=ESP_OK) {Serial.println("Failed to add peer"); return;}
}
 
void loop() 
{ myData.servoPos01=analogRead(ch01);  myData.servoPos02=analogRead(ch02);
  myData.servoPos03=analogRead(ch03);  myData.servoPos04=analogRead(ch04);
  esp_err_t result=esp_now_send(broadcastAddress, (uint8_t *) &myData, sizeof(myData));
  Serial.println(result==ESP_OK?"Delivery success":"Error sending data");
  delay(20);
}
