// Doorbell_Rx.ino
// ESP32 @ IDE 1.8.16

#include <esp_now.h>
#include <WiFi.h>

byte LEDpin=16;

typedef struct struct_message 
{bool sw;} struct_message;
struct_message myData;

void OnDataRecv(const uint8_t *mac, const uint8_t *incomingData, int len) 
{ memcpy(&myData, incomingData, sizeof(myData));
  Serial.print("Switch State: "); Serial.println(myData.sw);
  digitalWrite(LEDpin,!myData.sw);
}
 
void setup() 
{ Serial.begin(115200); WiFi.mode(WIFI_STA);
  pinMode(LEDpin,OUTPUT); digitalWrite(LEDpin,HIGH);
  if (esp_now_init()!=ESP_OK){Serial.println("Error initializing ESP-NOW"); return;}
  esp_now_register_recv_cb(OnDataRecv);
}
 
void loop() {}
