// Doorbell_Tx.ino
// ESP32 @ IDE 1.8.16

#include <esp_now.h>
#include <WiFi.h>

uint8_t broadcastAddress[] = {0x80,0x7D,0x3A,0xDC,0x67,0x1C}; // receiver MAC adress

byte LEDonPin=18;

typedef struct struct_message 
{bool sw;} struct_message;
struct_message myData;
esp_now_peer_info_t peerInfo;

void OnDataSent(const uint8_t *mac_addr, esp_now_send_status_t status) 
{ Serial.print(status==ESP_NOW_SEND_SUCCESS?"Data Sent\t":"Send Fail\t");}
 
void setup() 
{ Serial.begin(115200);  WiFi.mode(WIFI_STA);
  if (esp_now_init() != ESP_OK) { Serial.println("Error initializing ESP-NOW"); return;}
  esp_now_register_send_cb(OnDataSent);
  memcpy(peerInfo.peer_addr, broadcastAddress, 6);
  peerInfo.channel = 0; peerInfo.encrypt = false;
  if (esp_now_add_peer(&peerInfo) != ESP_OK) {  Serial.println("Failed to add peer"); return;}
  pinMode(LEDonPin,INPUT_PULLUP);
}
 
void loop() 
{ if (digitalRead(LEDonPin)==false)    myData.sw=true;
  else myData.sw=false;
  Serial.println(myData.sw);
  esp_err_t result=esp_now_send(broadcastAddress, (uint8_t *) &myData, sizeof(myData));
  Serial.println(result==ESP_OK?"Delivery Success":"Delivery Fail");
  delay(20);
}
